var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import { UserService } from "lsi-spfx-services";
import { Spinner } from "office-ui-fabric-react/lib/Spinner";
export var CurrentUserContext = React.createContext(null);
export var useCurrentUser = function () { return React.useContext(CurrentUserContext); };
export var CurrentUser = React.memo(function (props) {
    var _a = React.useState("idle"), loading = _a[0], setLoading = _a[1];
    var _b = React.useState(null), state = _b[0], setState = _b[1];
    React.useEffect(function () {
        setLoading("pending");
        UserService.setup(props.webPartContext);
        UserService.getCompleteCurrentUser()
            .then(function (user) {
            setState(user);
            setLoading("succeeded");
        })
            .catch(function (e) { return setLoading("failed"); });
    }, []);
    if (loading == "idle" || loading == "pending")
        return React.createElement(Spinner, { label: "Loading Current User" });
    if (loading == "failed")
        return React.createElement("div", null, "Something went wrong loading the current user");
    return (React.createElement(CurrentUserContext.Provider, { value: __assign({}, state) }, props.children));
});
//# sourceMappingURL=CurrentUser.js.map