var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { TextField } from "office-ui-fabric-react/lib/TextField";
import { isValidNumber } from "lsi-spfx-services/lib/helpers/string/isValidNumber";
var ERROR_INVALID_NUMBER = "The value of this field is not a valid number.";
export var NumberField = function (props) {
    var preventInvalidInput = props.preventInvalidInput, onChange = props.onChange, onGetErrorMessage = props.onGetErrorMessage, passThroughProps = __rest(props, ["preventInvalidInput", "onChange", "onGetErrorMessage"]);
    var _onChange = function (e, newValue) {
        if (preventInvalidInput && !isValidNumber(newValue)) {
            return; // Don't allow the update
        }
        if (onChange)
            onChange(e, newValue);
    };
    var _onGetErrorMessage = function (v) {
        if (!isValidNumber(v))
            return ERROR_INVALID_NUMBER;
        if (onGetErrorMessage)
            return onGetErrorMessage(v);
    };
    return (React.createElement(TextField, __assign({ onChange: _onChange, onGetErrorMessage: _onGetErrorMessage }, passThroughProps)));
};
//# sourceMappingURL=NumberField.js.map