import * as React from 'react';
import { debounce } from '@microsoft/sp-lodash-subset';
export var SortingAndFilteringContext = React.createContext(null);
export var SortingAndFiltering = React.memo(function (props) {
    var _a = React.useState(""), filterText = _a[0], setFilterText = _a[1];
    var _b = React.useState({ field: "ID", isSortedDescending: true }), sortOptions = _b[0], setSortOptions = _b[1];
    var onColumnClick = React.useCallback(function (e, column) {
        if (column.fieldName == sortOptions.field) {
            setSortOptions({ field: column.fieldName, isSortedDescending: !sortOptions.isSortedDescending });
        }
        else {
            setSortOptions({ field: column.fieldName, isSortedDescending: false });
        }
    }, [sortOptions]);
    var clearFilterText = React.useCallback(function (e) { return setFilterText(""); }, []);
    var updateFilterText = React.useCallback(debounce(function (e, newValue) {
        newValue = newValue || "";
        setFilterText(newValue);
    }, 200), []);
    return (React.createElement(SortingAndFilteringContext.Provider, { value: {
            filterText: filterText,
            clearFilterText: clearFilterText,
            updateFilterText: updateFilterText,
            sortOptions: sortOptions,
            onColumnClick: onColumnClick
        } }, props.children));
});
export var useSortingAndFiltering = function () { return React.useContext(SortingAndFilteringContext); };
//# sourceMappingURL=SortingAndFiltering.js.map