var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import React from 'react';
import styles from "./UserDetails.module.scss";
import { MessageBar, MessageBarType } from "office-ui-fabric-react/lib/MessageBar";
import { PersonaSize, Persona } from 'office-ui-fabric-react/lib/Persona';
import { CommandBarButton } from 'office-ui-fabric-react/lib/Button';
import { Spinner } from 'office-ui-fabric-react/lib/Spinner';
import { Modal } from 'office-ui-fabric-react/lib/Modal';
import { Stack } from 'office-ui-fabric-react/lib/Stack';
import { ContactLinkDetail } from './ContactLinkDetail';
import { OverviewUserSection } from './OverviewUserSection';
import { UserService } from "lsi-spfx-services";
export var UserDetails = function (_a) {
    var _b, _c, _d, _e, _f, _g, _h, _j, _k;
    var loginOrUpnOrEmail = _a.loginOrUpnOrEmail, onDismiss = _a.onDismiss, onSelectUser = _a.onSelectUser, hideManagement = _a.hideManagement, hidePeers = _a.hidePeers, hideReports = _a.hideReports;
    var _l = React.useState(true), loading = _l[0], setLoading = _l[1];
    var _m = React.useState(null), userProfile = _m[0], setUserProfile = _m[1];
    var loadProfile = function () { return __awaiter(void 0, void 0, void 0, function () {
        var login, user, profile, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setLoading(true);
                    login = loginOrUpnOrEmail;
                    if (!(login.indexOf("|") == -1)) return [3 /*break*/, 2];
                    return [4 /*yield*/, UserService.getUser(login).catch(function (e) { return ({ LoginName: "i:0#.f|membership|" + login }); })];
                case 1:
                    user = _a.sent();
                    login = user.LoginName;
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 4, , 5]);
                    return [4 /*yield*/, UserService.getUserProfile(login)];
                case 3:
                    profile = _a.sent();
                    setUserProfile(profile);
                    return [3 /*break*/, 5];
                case 4:
                    error_1 = _a.sent();
                    return [3 /*break*/, 5];
                case 5:
                    setLoading(false);
                    return [2 /*return*/];
            }
        });
    }); };
    React.useEffect(function () {
        loadProfile();
    }, [loginOrUpnOrEmail]);
    return (React.createElement(Modal, { styles: { main: { minWidth: 600 } }, isOpen: true, onDismiss: onDismiss, isBlocking: false, containerClassName: styles.userDetailsModal },
        loading &&
            React.createElement("div", { className: styles.centerSpinner },
                React.createElement(Spinner, { label: "Loading..." })),
        !loading &&
            React.createElement("div", null,
                !userProfile &&
                    React.createElement(MessageBar, { messageBarType: MessageBarType.blocked }, "Could not find user"),
                userProfile &&
                    React.createElement("div", { className: styles.userDetailsModalContainer },
                        React.createElement("div", { className: styles.userDetails },
                            React.createElement("div", { className: styles.personaContainer },
                                React.createElement("div", { className: styles.coinWrapper },
                                    React.createElement(Persona, { imageUrl: "/_layouts/15/userphoto.aspx?size=L&accountname=" + userProfile.Email, 
                                        // text={`${user.givenName} ${user.surname}`}
                                        size: PersonaSize.size100, imageAlt: userProfile.DisplayName })),
                                React.createElement("div", { className: styles.details },
                                    React.createElement("div", { className: styles.largePersonaTitle },
                                        React.createElement("div", null, userProfile.DisplayName)),
                                    React.createElement("div", { className: styles.secondary },
                                        userProfile.Title && React.createElement("span", { className: styles.addBullet }, userProfile.Title),
                                        ((_b = userProfile.UserProfilePropertyDictionary) === null || _b === void 0 ? void 0 : _b.Department) && React.createElement("span", null, (_c = userProfile.UserProfilePropertyDictionary) === null || _c === void 0 ? void 0 : _c.Department)),
                                    React.createElement("div", { className: styles.actionsContainer },
                                        React.createElement(CommandBarButton, { styles: { root: { background: "transparent", padding: "4px", height: "32px", borderWidth: 0 } }, iconProps: { iconName: 'Mail' }, text: "Send mail", onClick: function () {
                                                window.location.href = 'mailto:' + userProfile.Email;
                                            } })))),
                            React.createElement("div", null,
                                React.createElement("h3", null, "Contact Information"),
                                React.createElement(Stack, { horizontal: true, wrap: true },
                                    React.createElement(ContactLinkDetail, { label: "Email", iconName: "Mail", content: userProfile.Email }),
                                    React.createElement(ContactLinkDetail, { label: "Work Phone", iconName: "Phone", content: (_d = userProfile.UserProfilePropertyDictionary) === null || _d === void 0 ? void 0 : _d.WorkPhone }),
                                    React.createElement(ContactLinkDetail, { label: "Mobile", iconName: "Phone", content: (_e = userProfile.UserProfilePropertyDictionary) === null || _e === void 0 ? void 0 : _e.CellPhone }),
                                    React.createElement(ContactLinkDetail, { label: "Office", iconName: "Poi", content: (_f = userProfile.UserProfilePropertyDictionary) === null || _f === void 0 ? void 0 : _f.Office }),
                                    React.createElement(ContactLinkDetail, { label: "Company", iconName: "CityNext", content: (_g = userProfile.UserProfilePropertyDictionary) === null || _g === void 0 ? void 0 : _g.companyName }),
                                    React.createElement(ContactLinkDetail, { label: "Job Title", iconName: "Contact", content: (_h = userProfile.UserProfilePropertyDictionary) === null || _h === void 0 ? void 0 : _h.Title }),
                                    React.createElement(ContactLinkDetail, { label: "Department", iconName: "Group", content: (_j = userProfile.UserProfilePropertyDictionary) === null || _j === void 0 ? void 0 : _j.Department }),
                                    React.createElement(ContactLinkDetail, { label: "Office Location", iconName: "ProfileSearch", content: (_k = userProfile.UserProfilePropertyDictionary) === null || _k === void 0 ? void 0 : _k.SPS_Location })),
                                !hideManagement &&
                                    React.createElement(OverviewUserSection, { userLogins: userProfile.ExtendedManagers, label: "Management Chain", onSelectUser: onSelectUser, reverseDisplay: true }),
                                !hideReports &&
                                    React.createElement(OverviewUserSection, { userLogins: userProfile.DirectReports, label: "Direct Reports", onSelectUser: onSelectUser }),
                                !hidePeers &&
                                    React.createElement(OverviewUserSection, { userLogins: userProfile.Peers, label: "Works with", onSelectUser: onSelectUser })))))));
};
//# sourceMappingURL=UserDetails.js.map